%define name htdig
%define version 3.1.5
%define release 9.1mdk

Name:		%{name}
Summary:	A web indexing and searching system for a small domain or intranet
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		Networking/Other
URL:		http://www.htdig.org/
Source:		%{name}-%{version}.tar.bz2
Source1:    htdig-dbgen
Source2:	%{name}-rundig-accents.patch.bz2
Patch0:		%{name}.patch.bz2
Patch1:		%{name}-accents.patch.bz2
Patch2:		rundig.emptydb.patch.bz2
Patch3:		htdig-3.1.5-remote_dos.patch.bz2
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
The ht://Dig system is a complete world wide web indexing and searching system 
for a small domain or intranet. This system is not meant to replace the need 
for powerful internet-wide search systems like Lycos, Infoseek, Webcrawler and 
AltaVista. Instead it is meant to cover the search needs for a single company, 
campus, or even a particular sub section of a web site.

As opposed to some WAIS-based or web-server based search engines, ht://Dig can 
span several web servers at a site. The type of these different web servers 
doesn't matter as long as they understand the HTTP 1.0 protocol.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q

%patch0 -p1 -b .config
%patch1 -p1 -b .accents
%patch2 -p1 -b .emptydb
%patch3 -p1 -b .remote_dos


%build
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
	--bindir=%{_sbindir} --libexec=%{_libdir} --libdir=%{_libdir} \
	--mandir=%{_mandir} --sysconfdir=/etc/htdig \
	--localstatedir=/var/lib/htdig \
	--with-image-dir=/var/www/html/htdig \
	--with-cgi-bin-dir=/var/www/cgi-bin \
	--with-search-dir=/var/www/html
make


%install
make INSTALL_ROOT=$RPM_BUILD_ROOT install-strip
mkdir -p $RPM_BUILD_ROOT/etc/cron.daily
# ln -s ../../usr/sbin/rundig $RPM_BUILD_ROOT/etc/cron.daily/htdig-dbgen
cp $RPM_SOURCE_DIR/htdig-dbgen $RPM_BUILD_ROOT/etc/cron.daily/htdig-dbgen
ln -s ../../../../usr/share/doc/htdig-%{PACKAGE_VERSION} \
	$RPM_BUILD_ROOT/var/www/html/htdig/htdoc

cp $RPM_BUILD_ROOT/var/www/cgi-bin/htsearch $RPM_BUILD_ROOT%{_sbindir}

%pre
egrep "^htdig:" /etc/group >/dev/null
if [ $? = 1 ]; then
    # echo "adding htdig group"
    groupadd -r htdig
fi

egrep "^htdig:" /etc/passwd >/dev/null
if [ $? = 1 ]; then
    # echo "adding htdig user"
    useradd -r -g htdig -s "" -d /var/lib/htdig htdig 
fi

%preun
# we're uninstalling
if [ $1 = 0 ]; then

    egrep "^htdig:" /etc/passwd >/dev/null
    if [ $? = 0 ]; then
	# echo "removing htdig user"
	userdel htdig # userdel seems to nuke the group too..
    fi

    egrep "^htdig:" /etc/group >/dev/null
    if [ $? = 0 ]; then
	# echo "removing htdig group"
	groupdel htdig
    fi
fi

%clean
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%post
# Only run this if installing for the first time
if [ "$1" = 1 ]; then
	if [ -f /etc/httpd/conf/httpd.conf ];then
	SERVERNAME="`grep '^ServerName' /etc/httpd/conf/httpd.conf | awk 'NR == 1 {print $2}'`"
	fi
	[ -z "$SERVERNAME" ] && SERVERNAME="`hostname -f`"
	[ -z "$SERVERNAME" ] && SERVERNAME="localhost"
	sed 's/^start_url:.*/#&\
# (See end of file for this parameter.)/' /etc/htdig/htdig.conf > /tmp/ht.$$
	cat /tmp/ht.$$ > /etc/htdig/htdig.conf
	rm /tmp/ht.$$
	cat >> /etc/htdig/htdig.conf <<!

# Automatically set up by htdig RPM, from your current Apache httpd.conf...
# Verify and configure these, and set maintainer above, before running
# /usr/sbin/rundig.
# See /usr/doc/htdig*/attrs.html for descriptions of attributes.

# The URL(s) where htdig will start.  See also limit_urls_to above.
start_url:	http://$SERVERNAME/

# This makes sure that we don't spider the web
local_urls_only: true

# These attributes allow indexing server via local filesystem rather than HTTP.
local_urls:	http://$SERVERNAME/=/var/www/html/
local_user_urls:	http://$SERVERNAME/=/home/,/public_html/
!

fi


%files
%defattr(-,root,root,0755)
%doc CONFIG README htdoc/*
%config(noreplace) %{_sysconfdir}/htdig/htdig.conf
%{_sbindir}/rundig
/var/www/html/search.html
%config(missingok, noreplace) %attr(0755,root,root) /etc/cron.daily/htdig-dbgen
%{_sbindir}/htdig
%{_sbindir}/htfuzzy
%{_sbindir}/htmerge
%{_sbindir}/htnotify
%{_sbindir}/htsearch
%attr(-,htdig,htdig) /var/lib/htdig
/var/www/cgi-bin/htsearch
/var/www/html/htdig


%changelog
* Sat Oct 20 2001 Vincent Danen <vdanen@mandrakesoft.com> 3.1.5-9.1mdk
- security update for 8.0

* Mon Feb  5 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1.5-9mdk
- grep httpd.conf only if exist.

* Fri Dec 29 2000 Renaud Chaillat <rchaillat@mandrakesoft.com> 3.1.5-8mdk
- patch to avoid using htmerge when database is empty 
 (avoid error message being sent by cron job)
- added '-a' option to rundig in the cron script, to allow searching 
  while a new index is created (in separate *.work files)
- corrected doc link

* Fri Nov 17 2000 Lenny Cartier <lenny@mandrakesoft.com> 3.1.5-7mdk
- build for gcc-2.96

* Fri Sep 15 2000 Renaud Chaillat <rchaillat@mandrakesoft.com> 3.1.5-6mdk
- well, changed /var/www/httpd to /var/www ; don't know what I was 
  thinking...

* Thu Sep 14 2000 Renaud Chaillat <rchaillat@mandrakesoft.com> 3.1.5-5mdk
- added noreplace for cron daily job
- added accent patches

* Thu Sep 14 2000 Renaud Chaillat <rchaillat@mandrakesoft.com> 3.1.5-4mdk
- moved /home/httpd to /var/www/httpd
- copied htsearch to sbindir to allow users to search locally

* Wed Sep 06 2000 Lenny Cartier <lenny@mandrakesoft.com> 3.1.5-3mdk
- BM
- macros

* Wed Apr 12 2000 Chris Green <cmg@dok.org> 3.1.5-2mdk
- made htdig run as the htdig user
- added noreplace to config file
    
* Tue Apr 11 2000 Lenny Cartier <lenny@mandrakesoft.com> 3.1.5-1mdk
- used srpm provided by Vincent Danen <vdanen@linux-mandrake.com>

* Fri Mar 24 2000 Vincent Danen <vdanen@linux-mandrake.com>
- adapted spec file by Gilles Detillieux <grdetil@scrc.umanitoba.ca>
- 3.1.5
- bzip sources
